import * as skyid from './skyid_fa_sdkv2.1-min.js'


 // inject SDK component in  HTML code
let skyid_liveness = document.getElementById('skyid_liveness'); // skyid_liveness a div id in the html code. 
skyid_liveness.innerHTML = skyid.skyid_component;
  


var skyid_fa_sdk_params_url = "***"
var OCR_url ="***"
var LIVENESS_url ="***"
var FACE_MATCHING_url ="***"

var skyid_fa_sdk_user = "***";
var skyid_fa_sdk_password = "***";

const skyid_fa_sdk_token = '***';
const skyid_fa_sdk_appId = '***';

var document_uniqueNameGuid = null ; 



  async function skyid_fa_get_params_request(skyid_fa_auth)
  {
         // setup request parameters
         let form_data = new FormData();
         form_data.append("token",skyid_fa_sdk_token);
         form_data.append("application_id",skyid_fa_sdk_appId);
         
         $.ajax({
             url : skyid_fa_sdk_params_url+"get_parameters_web_sdk",
             type : "POST",
             headers : {"Authorization":"Bearer "+skyid_fa_auth},
             data : form_data,
             cache : false,
             contentType : false,
             processData : false,
             success : function(response) {
                            if(response["status_code"]=="000")
                            {
                                const sdk_data=response["response_data"];
                                // skyid sdk methods call
                                skyid.skyid_fa_init_sdk(sdk_data);
                            }else
                            {
                                alert(response["status_label"]);
                            }
             },
             error: function(xhr, status, error) {
                 alert(xhr.status+" : "+xhr.statusText);
             }
           });
  
  }
  
async function skyid_fa_remote_sdk_initialization()
{
    var form = new FormData();
    form.append("username", skyid_fa_sdk_user);
    form.append("password", skyid_fa_sdk_password);
  
    $.ajax({
        url : skyid_fa_sdk_params_url+"login",
        type : "POST",
        data : form,
        cache : false,
        contentType : false,
        processData : false,
        success : function(response) {
            if(response["status_code"]=="000")
            {
                const skyid_fa_setup_data=response["response_data"];
                const temp_token = skyid_fa_setup_data["access_token"]
                // call get parameters api with the obtained token
                skyid_fa_get_params_request(temp_token);
            }else
            {
                alert(skyid_fa_init_error_callback);
            }
        },
        error: function(xhr, status, error) {
            alert(xhr.status+" : "+xhr.statusText);
        }
      });
}

// init SDK with the defined method
await skyid_fa_remote_sdk_initialization()

  
document.getElementById('skyid_fa_start_button').addEventListener('click', function () {
    skyid.skyid_fa_start_face_scan(skyid_fa_face_scan_end_callback, process_fa_timeOut);
});



var skyid_fa_auth_token =  null ;
function skyid_fa_check_liveness_request(skyid_fa_auth,frame_canvas)
{
    skyid_fa_auth_token = skyid_fa_auth; 
   //create binary image file
  const canvas_bin = skyid_fa_canvas2binary(frame_canvas);
  const  face_image= new File([canvas_bin], "skyid_fa_selected_frame.jpg",{type:"application/octet-stream"})
  // setup request parameters
  let form_data = new FormData();
  form_data.append("selfie",face_image);
  // send request
  $.ajax({
      url : LIVENESS_url,
      type : "POST",
      headers : {"Authorization":"Bearer "+skyid_fa_auth},
      data : form_data,
      cache : false,
      contentType : false,
      processData : false,
      success : function(response) {
          loaddatalivnssElement.style.display = "none";
            if(response["status_code"]=="000")
            {
                let api_result=response["response_data"]
                if(api_result["face_class"]=="Real")
                {
                    skyid.skyid_fa_start_face_scan(skyid_fa_face_scan_end_callbackfacematching, process_fa_timeOut);
                   
                    const resultextractdata = document.getElementById('responseOneDisplayrealtimefacedetct');

                    // Format and display the JSON data in the element
                    resultextractdata.innerHTML = '<pre>' + JSON.stringify(response.response_data, null, 2) + '</pre>';


                    
                    const stepNumber = 3; // The desired step_number value
                    const button = document.querySelector(`button[step_number="${stepNumber}"]`);
        
                    setTimeout(function() {
                        // This code will be executed after the delay 1sec
                        button.disabled = false; // Enable the button
                        button.style.background = '#4361ee'; // Set its background color
                      }, 1000);

                

                }else{
                     alert("echec de verification preuve de vue, SVP reessayer dans un environement limunaux");
                }
                $( "#msg" ).html("Result :"+api_result["face_class"]+" score "+api_result["score"]+"<br/><br/>");
            }
            else{
                 alert("echec de verification preuve de vue, SVP reessayer dans un environement limunaux")
            }

          	  $( "#skyid_fa_start_button" ).html("Redemarrer");
              $( "#skyid_fa_start_button" ).show();

      },
      error: function(xhr, status, error) {
        loaddatalivnssElement.style.display = "none";
          alert(xhr.status+" : "+xhr.statusText);
      }
    });
}

function skyid_fa_canvas2binary(req_canvas)
{
    let skyid_fa_canvas_data = req_canvas.toDataURL('image/jpeg', 1.0);
    skyid_fa_canvas_data = skyid_fa_canvas_data.replace('data:image/jpeg;base64,', '');
    return skyid_fa_base64ToArrayBuffer(skyid_fa_canvas_data)
}
function skyid_fa_base64ToArrayBuffer(base64) {
	const binary_string =  window.atob(base64);
	const len = binary_string.length;
	var bytes = new Uint8Array( len );
	for (var i = 0; i < len; i++)        {
		bytes[i] = binary_string.charCodeAt(i);
	}
	return bytes.buffer;
}




function skyid_fa_check_liveness(frame_canvas)
{
  var form = new FormData();
  form.append("username", skyid_fa_sdk_user);
  form.append("password", skyid_fa_sdk_password);
  loaddatalivnssElement.style.display = "block";
  $.ajax({
      url : skyid_fa_sdk_params_url+"login",
      type : "POST",
      data : form,
      cache : false,
      contentType : false,
      processData : false,
      success : function(response) {
          if(response["status_code"]=="000")
          {
              const skyid_fa_setup_data=response["response_data"];
              const temp_token = skyid_fa_setup_data["access_token"]
              skyid_fa_check_liveness_request(temp_token,frame_canvas);
          }else
          {
              alert(response["status_label"]);
          }
      },
      error: function(xhr, status, error) {
          alert(xhr.status+" : "+xhr.statusText);
      }
    });
}
var my_selfie_canvas = null;
function skyid_fa_face_scan_end_callback(skyid_fa_detected_face_canvas)
{
    my_selfie_canvas=skyid_fa_detected_face_canvas
    skyid_fa_check_liveness(skyid_fa_detected_face_canvas);
}
function process_fa_timeOut() {
    // process_fa_timeOut function 
  }


function skyid_fa_extract_info_from_document()
{
  var form = new FormData();
  form.append("username", skyid_fa_sdk_user);
  form.append("password", skyid_fa_sdk_password);

  $.ajax({
      url : skyid_fa_sdk_params_url+"login",
      type : "POST",
      data : form,
      cache : false,
      contentType : false,
      processData : false,
      success : function(response) {
          if(response["status_code"]=="000")
          {
              const skyid_fa_setup_data=response["response_data"];
              const temp_token = skyid_fa_setup_data["access_token"]
              SmartOcrGetInfo(temp_token) ; 

          }else
          {
              alert(response["status_label"]);
          }
      },
      error: function(xhr, status, error) {
          alert(xhr.status+" : "+xhr.statusText);
      }
    });
}

// loader spinner  
const loaddataocrElement = document.getElementById("loaddataocr");
const loaddatalivnssElement = document.getElementById("loaddatalvnss");
const loaddatafacemtchElement = document.getElementById("loaddatafacemtch");



function SmartOcrGetInfo(temp_token){
    const imageInput = document.getElementById("ocrimagge");
    if (!imageInput.files.length) {
        alert("Please select an image.");
        return;
    }else {
        loaddataocrElement.style.display = "block";
        
            const formData = new FormData();
            // Add other form fields as needed
            formData.append("document", imageInput.files[0]);
            formData.append('institution_id', '***');
            formData.append('channel_id', '***');

            // Service id specifies the document you want to analyze and information extraction, 
            formData.append('service_id', '***');
            formData.append('sub_service_id', '***');

            // define the type of document to analyse. in this use case is always the same as service ID.
            formData.append('request_data', '{"doc_type":"***"}');
            formData.append("token",skyid_fa_sdk_token);
            formData.append("application_id",skyid_fa_sdk_appId);


            $.ajax({
                type: "POST",
                url: OCR_url,
                data: formData,
                headers : {"Authorization":"Bearer "+temp_token},
                processData: false,
                contentType: false,
                success:  function (response) {
                    loaddataocrElement.style.display = "none";
                    if (response.status_code =="000"){
                    // Get the HTML element by its id
                    const resultextractdata = document.getElementById('resultextractdata');
                    document_uniqueNameGuid= null ; 
                    document_uniqueNameGuid=  response.response_data.document_uniqueName ; 
                    // Format and display the JSON data in the element
                    resultextractdata.innerHTML = '<pre>' + JSON.stringify(response.response_data, null, 2) + '</pre>';
                    
                    const stepNumber = 2; // The desired step_number value
                    const button = document.querySelector(`button[step_number="${stepNumber}"]`);
        
                    button.disabled = false; // To disable the button
                    button.style.background = '#4361ee'; // Set its background color
                     
                    }else {
                        const resultextractdata = document.getElementById('resultextractdata');
        
                        // Format and display the JSON data in the element
                        resultextractdata.innerHTML = '<pre>' + response.status_label + '</pre>';
        
                    }
                },
                error: function (error) {
                     loaddataocrElement.style.display = "none";
                     alert("Image upload failed.");
                }
            });
    }




}

document.getElementById('smart_ocr_get_info').addEventListener('click', function () {
    skyid_fa_extract_info_from_document() ; 
  
});






const imageContainer = document.getElementById("imageContainer");
const imageInput = document.getElementById("ocrimagge");
const uploadedImageocr = document.getElementById("uploadedImageocr");


imageInput.addEventListener("change", function () {
    const file = imageInput.files[0]; // Get the selected file
    
    if (file) {
      // Create a URL for the selected image
      const imageURL = URL.createObjectURL(file);
      
      // Display the image in the div
      uploadedImageocr.src = imageURL;
      imageContainer.style.display = "block"; // Make the container visible
    }
  });
  


function skyid_fa_face_scan_end_callbackfacematching(skyid_fa_detected_face_canvas)
{
    my_selfie_canvas=skyid_fa_detected_face_canvas

    loaddatafacemtchElement.style.display = "block";

    if (!imageInput.files.length) {
        alert("Please select an image.");
        return;
    } 
        //Add other form fields as needed
        const canvas_bin = skyid_fa_canvas2binary(my_selfie_canvas);
        const  face_image= new File([canvas_bin], "skyid_fa_selected_frame.jpg",{type:"application/octet-stream"})
        const formDatafacemtch = new FormData();
        // Add other form fields as needed
        formDatafacemtch.append("doc_1_1", imageInput.files[0]);
        formDatafacemtch.append("slf_1", face_image);
        formDatafacemtch.append('guid', document_uniqueNameGuid);
        formDatafacemtch.append("token",skyid_fa_sdk_token);
        formDatafacemtch.append("application_id",skyid_fa_sdk_appId);


        $.ajax({
        type: "POST",
        url:  FACE_MATCHING_url,
        data: formDatafacemtch,
        headers : {"Authorization":"Bearer "+skyid_fa_auth_token},
        processData: false,
        contentType: false,
        success: function (response) {

            loaddatafacemtchElement.style.display = "none";
            if (response.status_code =="000"){
                const resultextractdata = document.getElementById('responseOneDisplayrealtimefacedetcttow');
    
                // Format and display the JSON data in the element
                resultextractdata.innerHTML = '<pre>' + JSON.stringify(response.multi_response_data.doc_1.response_data, null, 2) + '</pre>';
            }else {
                
                const resultextractdata = document.getElementById('responseOneDisplayrealtimefacedetcttow');
    
                // Format and display the JSON data in the element
                resultextractdata.innerHTML = '<pre>' + JSON.stringify(response.status_label, null, 2) + '</pre>';
            }           
        },
        error: function (error) {
            alert("failed.");
        loaddatafacemtchElement.style.display = "none";
        }
    });
}

  


// reset  navigateToFormStep
function reloadall(){
    const fileInput = document.getElementById("ocrimagge");
    fileInput.value = null;
    
    
    const resultextractdata = document.getElementById('resultextractdata');
    uploadedImageocr.src = "assets/CINcrt.jpg";
    resultextractdata.innerHTML = '<pre> Download your national card (CIN - recto )  </pre>';


    const resultextfacemtchlvnssdata = document.getElementById('responseOneDisplayrealtimefacedetct');
    resultextfacemtchlvnssdata.innerHTML = '<pre></pre>';

    const resultexfacemtchdata = document.getElementById('responseOneDisplayrealtimefacedetcttow');
    resultexfacemtchdata.innerHTML = '<pre></pre>';

    
    const step2= 2 ; 
    const buttonstep2 = document.querySelector(`button[step_number="${step2}"]`);
    
    buttonstep2.disabled = true; // To disable the button
    buttonstep2.style.background = 'darkgray' ; 
    
    const step3= 3 ; 
    const buttonstep3 = document.querySelector(`button[step_number="${step3}"]`);
    
    buttonstep3.disabled = true; // To disable the button
    buttonstep3.style.background = 'darkgray' ; 


}

/**
 * Define a function to navigate betweens form steps.
 * It accepts one parameter. That is - step number.
 */
const navigateToFormStep = (stepNumber) => {
    if (stepNumber == 1){
        reloadall() ; 
    }
    if (stepNumber==2){

        skyid.skyid_fa_setup_sdk();
    }else{
        skyid.skyid_fa_stop_webcam() ;
    }
    /**
     * Hide all form steps.
     */
    document.querySelectorAll(".form-step").forEach((formStepElement) => {
        formStepElement.classList.add("d-none");
    });
    /**
     * Mark all form steps as unfinished.
     */
    document.querySelectorAll(".form-stepper-list").forEach((formStepHeader) => {
        formStepHeader.classList.add("form-stepper-unfinished");
        formStepHeader.classList.remove("form-stepper-active", "form-stepper-completed");
    });
    /**
     * Show the current form step (as passed to the function).
     */
    document.querySelector("#step-" + stepNumber).classList.remove("d-none");
    /**
     * Select the form step circle (progress bar).
     */
    const formStepCircle = document.querySelector('li[step="' + stepNumber + '"]');
    /**
     * Mark the current form step as active.
     */
    formStepCircle.classList.remove("form-stepper-unfinished", "form-stepper-completed");
    formStepCircle.classList.add("form-stepper-active");
    /**
     * Loop through each form step circles.
     * This loop will continue up to the current step number.
     * Example: If the current step is 3,
     * then the loop will perform operations for step 1 and 2.
     */
    for (let index = 0; index < stepNumber; index++) {
        /**
         * Select the form step circle (progress bar).
         */
        const formStepCircle = document.querySelector('li[step="' + index + '"]');
        /**
         * Check if the element exist. If yes, then proceed.
         */
        if (formStepCircle) {
            /**
             * Mark the form step as completed.
             */
            formStepCircle.classList.remove("form-stepper-unfinished", "form-stepper-active");
            formStepCircle.classList.add("form-stepper-completed");
        }
    }
};
/**
 * Select all form navigation buttons, and loop through them.
 */
document.querySelectorAll(".btn-navigate-form-step").forEach((formNavigationBtn) => {
    /**
     * Add a click event listener to the button.
     */
    formNavigationBtn.addEventListener("click", () => {
        /**
         * Get the value of the step.
         */
        const stepNumber = parseInt(formNavigationBtn.getAttribute("step_number"));
        /**
         * Call the function to navigate to the target form step.
         */
        navigateToFormStep(stepNumber);
    });
});
